#![recursion_limit = "512"]

extern crate proc_macro;

use proc_macro::TokenStream;
use quote::quote;

#[proc_macro_attribute]
pub fn create_interface(_attr: TokenStream, item: TokenStream) -> TokenStream {
    let input = syn::parse_macro_input!(item as syn::ItemFn);

    let ret = &input.sig.output;
    let body = &input.block;
    let attrs = &input.attrs;

    let result = quote! {
        #[no_mangle]
        pub static mut g_ServerPlugin: *mut std::ffi::c_void = 0 as _;
        #[no_mangle]
        #[allow(unused_variables)]
        pub unsafe extern "C" fn CreateInterface(version: *const i8, result: *mut i32) -> *mut std::ffi::c_void {
            #(#attrs)*
            fn inner() #ret {
                #body
            }
            if g_ServerPlugin.is_null() {
                g_ServerPlugin = std::mem::transmute(Box::new(server_plugin::BasePlugin::new(inner())))
            }
            g_ServerPlugin
        }
    };
    result.into()
}
