use std::ffi::c_void;
use std::os::raw::c_char;

use vtables::VTable;
use vtables_derive::virtual_index;

use crate::inetworkstringtable::{INetworkStringTable, INetworkStringTableContainer};

impl INetworkStringTable {
    #[virtual_index(1)]
    pub(in crate) fn get_table_name_internal(&self) -> *const c_char {}
    #[virtual_index(2)]
    pub fn get_table_id(&self) -> i32 {}
    #[virtual_index(3)]
    pub fn get_num_strings(&self) -> i32 {}
    #[virtual_index(4)]
    pub fn get_max_strings(&self) -> i32 {}
    #[virtual_index(5)]
    pub fn get_entry_bits(&self) -> i32 {}
    #[virtual_index(6)]
    pub fn set_tick(&self, tick: i32) {}
    #[virtual_index(7)]
    pub fn changed_since_tick(&self, tick: i32) -> bool {}
    #[virtual_index(8)]
    pub(in crate) fn add_string_internal(
        &self,
        is_server: bool,
        value: *const c_char,
        length: i32,
        data: *const c_void,
    ) -> i32 {
    }
    #[virtual_index(9)]
    pub(in crate) fn get_string_internal(&self, string_number: i32) -> *const c_char {}
    #[virtual_index(10)]
    pub(in crate) fn set_string_userdata_internal(&self, string_number: i32, length: i32, data: *const c_void) {}
    #[virtual_index(11)]
    pub(in crate) fn get_string_userdata_internal(&self, string_number: i32, length: *mut i32) -> *const c_void {}
}

impl INetworkStringTableContainer {
    #[virtual_index(1)]
    pub(in crate) fn create_string_table_internal(
        &self,
        table_name: *const c_char,
        max_entries: i32,
        userdatafixedsize: i32,
        userdatanetworkbits: i32,
    ) -> *mut c_void {
    }
    #[virtual_index(2)]
    pub fn remove_all_tables(&self) {}
    #[virtual_index(3)]
    pub(in crate) fn find_table_internal(&self, table_name: *const c_char) -> *const INetworkStringTable {}
    #[virtual_index(4)]
    pub(in crate) fn get_table_internal(&self, string_table: i32) -> *const INetworkStringTable {}
    #[virtual_index(5)]
    pub fn get_num_tables(&self) -> i32 {}
    #[virtual_index(6)]
    pub(in crate) fn create_string_table_ex_internal(
        &self,
        table_name: *const c_char,
        max_entries: i32,
        userdatafixedsize: i32,
        userdatanetworkbits: i32,
        is_file_names: bool,
    ) -> *mut c_void {
    }
    #[virtual_index(7)]
    pub(in crate) fn set_allow_clientside_add_internal(
        &self,
        table: *mut c_void,
        allow_clientside_add_sring: bool,
    ) -> *mut c_void {
    }
}